//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis                         
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-                                
//*  http://apps.jcns.fz-juelich.de/frida                                   
//**************************************************************************************************

//! \file  special.hpp
//! \brief NSpecial: this and that, written ad hoc.

//  What falls out of use goes to ../../arch/one-time-routines/

#include <complex>
using std::complex;

#include "gsl/gsl_sf_trig.h"

namespace NSpecial {
    void FourierCosine();
    void Test();

    template<typename T>
    complex<T> pssc( T z )
    {
        complex<T> ci( 0.L, 1.L );
        complex<T> cone( 1.L, 0.L );
        return z==0 ? -ci : (cone-std::exp(ci*z))/z;
//        T z2 = z / (T)(2.L);
//        return -ci * std::sin(z2) / (z2) * std::exp(ci*z2);
    }

    template<typename T>
    complex<T> ff_test( T a, T b )
    {
        return complex<T>(T(1.L)/b,T(0.L)) * ( pssc(a+b) - pssc(a-b) );
    }    
}
